Index: drivers/scsi/nsp32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/nsp32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/nsp32.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/nsp32.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -3165,7 +3083,12 @@
 {
 	int vendor = data->pci_devid->vendor;
 	int device = data->pci_devid->device;
-	int ret, val, i;
+	int ret;
+#ifdef NSP32_DEBUG
+	int i;
+#define NSP32_DEBUG_PROM_BUF_SIZE 0x20
+	unsigned char buf[NSP32_DEBUG_PROM_BUF_SIZE];
+#endif
 
 	/*
 	 * EEPROM checking.
@@ -3173,12 +3096,12 @@
 	ret = nsp32_prom_read(data, 0x7e);
 	if (ret != 0x55) {
 		nsp32_msg(KERN_INFO, "No EEPROM detected: 0x%x", ret);
-		return (FALSE);
+		return FALSE;
 	}
 	ret = nsp32_prom_read(data, 0x7f);
 	if (ret != 0xaa) {
 		nsp32_msg(KERN_INFO, "Invalid number: 0x%x", ret);
-		return (FALSE);
+		return FALSE;
 	}
 
 	/*
@@ -3186,27 +3109,30 @@
 	 */
 	if (vendor == PCI_VENDOR_ID_WORKBIT &&
 	    device == PCI_DEVICE_ID_WORKBIT_STANDARD) {
-		ret = nsp32_getprom_standard(data);
+		ret = nsp32_getprom_c16(data);
 	} else if (vendor == PCI_VENDOR_ID_WORKBIT &&
 		   device == PCI_DEVICE_ID_NINJASCSI_32BIB_LOGITEC) {
-		ret = nsp32_getprom_new(data);
+		ret = nsp32_getprom_at24(data);
 	} else if (vendor == PCI_VENDOR_ID_WORKBIT &&
 		   device == PCI_DEVICE_ID_NINJASCSI_32UDE_MELCO ) {
-		ret = nsp32_getprom_new(data);
+		ret = nsp32_getprom_at24(data);
 	} else {
 		nsp32_msg(KERN_WARNING, "Unknown EEPROM");
 		ret = FALSE;
 	}
 
+#ifdef NSP32_DEBUG
 	/* for debug : SPROM data full checking */
-	for (i=0; i<=0x1f; i++) {
-		val = nsp32_prom_read(data, i);
-		nsp32_dbg(NSP32_DEBUG_EEPROM,
-			  "rom address 0x%x : 0x%x", i, val);
+	nsp32_dbg(NSP32_DEBUG_EEPROM, "rom dump");
+	for (i = 0; i < sizeof(buf); i++) {
+		buf[i] = nsp32_prom_read(data, i);
 	}
+	nsp32_byte_dump(buf, 0, sizeof(buf));
+#endif
 
-	return (ret);
+	return ret;
 }
+#undef NSP32_DEBUG_PROM_BUF_SIZE
 
 
 /*
@@ -3233,15 +3159,15 @@
  *   0x1c        :  Constant? (0x01) (clock div?)
  *   0x1d - 0x7c :  Not Used (0xff)
  *   0x7d	 :  Not Used? (0xff)
- *   0x7e        :  Constant (0x55), HBA chip revision
- *   0x7f        :  Constant (0xaa), HBA value
+ *   0x7e        :  Constant (0x55), Validity signature
+ *   0x7f        :  Constant (0xaa), Validity signature
  */
-static int nsp32_getprom_new(nsp32_hw_data *data)
+static int nsp32_getprom_at24(nsp32_hw_data *data)
 {
-	int ret, i;
-	int auto_sync;
-	struct nsp32_target *target;
-	int entry;
+	int           ret, i;
+	int           auto_sync;
+	nsp32_target *target;
+	int           entry;
 
 	/*
 	 * Reset time which is designated by EEPROM.
@@ -3273,8 +3199,7 @@
 		break;
 	default:
 		nsp32_msg(KERN_WARNING,
-			  "Unsupported Auto Sync mode."
-			  "Fall back to manual mode.");
+			  "Unsupported Auto Sync mode. Fall back to manual mode.");
 		auto_sync = TRUE;
 	}
 
@@ -3285,12 +3210,12 @@
 	/*
 	 * each device Synchronous Transfer Period
 	 */
-	for (i=0; i<NSP32_HOST_SCSIID; i++) {
+	for (i = 0; i < NSP32_HOST_SCSIID; i++) {
 		target = &data->target[i];
 		if (auto_sync == TRUE) {
 			target->limit_entry = 0;   /* set as ULTRA20M */
 		} else {
-			ret = nsp32_prom_read(data, i);
+			ret   = nsp32_prom_read(data, i);
 			entry = nsp32_search_period_entry(data, target, ret);
 			if (entry < 0) {
 				/* search failed... set maximum speed */
@@ -3300,12 +3225,12 @@
 		}
 	}
 
-	return (TRUE);
+	return TRUE;
 }
 
 
 /*
- * ? (I-O Data: SC-NBD) data map:
+ * C16 110 (I-O Data: SC-NBD) data map:
  *
  *   ROMADDR
  *   0x00 - 0x06 :  Device Synchronous Transfer Period (SCSI ID 0 - 6) 
@@ -3321,14 +3246,14 @@
  *			Value 0: Disable, 1: Enable
  *   0x1a - 0x7c :  Not Used? (0)
  *   0x7d	 :  Not Used? (0xf8)
- *   0x7e        :  Constant (0x55), HBA chip revision
- *   0x7f        :  Constant (0xaa), HBA value
+ *   0x7e        :  Constant (0x55), Validity signature
+ *   0x7f        :  Constant (0xaa), Validity signature
  */
-static int nsp32_getprom_standard(nsp32_hw_data *data)
+static int nsp32_getprom_c16(nsp32_hw_data *data)
 {
-	int ret, i;
-	struct nsp32_target *target;
-	int entry, val;
+	int           ret, i;
+	nsp32_target *target;
+	int           entry, val;
 
 	/*
 	 * Reset time which is designated by EEPROM.
@@ -3340,7 +3265,7 @@
 	/*
 	 * each device Synchronous Transfer Period
 	 */
-	for (i=0; i<NSP32_HOST_SCSIID; i++) {
+	for (i = 0; i < NSP32_HOST_SCSIID; i++) {
 		target = &data->target[i];
 		ret = nsp32_prom_read(data, i);
 		switch (ret) {
@@ -3354,10 +3279,11 @@
 			val = 0x32;
 			break;
 		case 3:		/* ASYNC */
-			val = 0x0;
+			val = 0x00;
 			break;
 		default:	/* default 20MB/s */
 			val = 0x0c;
+			break;
 		}
 		entry = nsp32_search_period_entry(data, target, val);
 		if (entry < 0 || trans_mode == ULTRA20M_MODE) {
@@ -3367,7 +3293,7 @@
 		target->limit_entry = entry;
 	}
 
-	return (TRUE);
+	return TRUE;
 }
 
 
@@ -3382,145 +3308,314 @@
 	nsp32_prom_start(data);
 
 	/* device address */
-	nsp32_prom_write(data, 1);	/* 1 */
-	nsp32_prom_write(data, 0);	/* 0 */
-	nsp32_prom_write(data, 1);	/* 1 */
-	nsp32_prom_write(data, 0);	/* 0 */
-	nsp32_prom_write(data, 0);	/* A2: 0 (GND) */
-	nsp32_prom_write(data, 0);	/* A1: 0 (GND) */
-	nsp32_prom_write(data, 0);	/* A0: 0 (GND) */
+	nsp32_prom_write_bit(data, 1);	/* 1 */
+	nsp32_prom_write_bit(data, 0);	/* 0 */
+	nsp32_prom_write_bit(data, 1);	/* 1 */
+	nsp32_prom_write_bit(data, 0);	/* 0 */
+	nsp32_prom_write_bit(data, 0);	/* A2: 0 (GND) */
+	nsp32_prom_write_bit(data, 0);	/* A1: 0 (GND) */
+	nsp32_prom_write_bit(data, 0);	/* A0: 0 (GND) */
 
 	/* R/W: W for dummy write */
-	nsp32_prom_write(data, 0);
+	nsp32_prom_write_bit(data, 0);
 
 	/* ack */
-	nsp32_prom_write(data, 0);
+	nsp32_prom_write_bit(data, 0);
 
 	/* word address */
-	for (i=7; i>=0; i--) {
-		nsp32_prom_write(data, ((romaddr >> i) & 1));
+	for (i = 7; i >= 0; i--) {
+		nsp32_prom_write_bit(data, ((romaddr >> i) & 1));
 	}
 
 	/* ack */
-	nsp32_prom_write(data, 0);
+	nsp32_prom_write_bit(data, 0);
 
 	/* start condition */
 	nsp32_prom_start(data);
 
 	/* device address */
-	nsp32_prom_write(data, 1);	/* 1 */
-	nsp32_prom_write(data, 0);	/* 0 */
-	nsp32_prom_write(data, 1);	/* 1 */
-	nsp32_prom_write(data, 0);	/* 0 */
-	nsp32_prom_write(data, 0);	/* A2: 0 (GND) */
-	nsp32_prom_write(data, 0);	/* A1: 0 (GND) */
-	nsp32_prom_write(data, 0);	/* A0: 0 (GND) */
+	nsp32_prom_write_bit(data, 1);	/* 1 */
+	nsp32_prom_write_bit(data, 0);	/* 0 */
+	nsp32_prom_write_bit(data, 1);	/* 1 */
+	nsp32_prom_write_bit(data, 0);	/* 0 */
+	nsp32_prom_write_bit(data, 0);	/* A2: 0 (GND) */
+	nsp32_prom_write_bit(data, 0);	/* A1: 0 (GND) */
+	nsp32_prom_write_bit(data, 0);	/* A0: 0 (GND) */
 
 	/* R/W: R */
-	nsp32_prom_write(data, 1);
+	nsp32_prom_write_bit(data, 1);
 
 	/* ack */
-	nsp32_prom_write(data, 0);
+	nsp32_prom_write_bit(data, 0);
 
 	/* data... */
 	val = 0;
-	for (i=7; i>=0; i--) {
-		val += (nsp32_prom_fetch(data) << i);
+	for (i = 7; i >= 0; i--) {
+		int bit = nsp32_prom_read_bit(data) ? 1 : 0;
+
+		val |= (bit << i);
 	}
 	
 	/* no ack */
-	nsp32_prom_write(data, 1);
+	nsp32_prom_write_bit(data, 1);
 
 	/* stop condition */
 	nsp32_prom_stop(data);
 
-	return (val);
+	return val;
 }
 
 static void nsp32_prom_start (nsp32_hw_data *data)
 {
 	/* start condition */
-	nsp32_prom_set(data, SCL, 1);
-	nsp32_prom_set(data, SDA, 1);
-	nsp32_prom_set(data, ENA, 1);	/* output mode */
-	nsp32_prom_set(data, SDA, 0);	/* keeping SCL=1 and transiting
-					 * SDA 1->0 is start condition */
-	nsp32_prom_set(data, SCL, 0);
+	nsp32_prom_set(data, SROM_CTL,    1);
+	nsp32_prom_set(data, SROM_DATA,   1);
+	nsp32_prom_set(data, SROM_ENABLE, 1); /* output mode */
+	nsp32_prom_set(data, SROM_DATA,   0); /* keeping SROM_CTL=1 and transiting
+					       * SROM_DATA 1->0 is start condition */
+	nsp32_prom_set(data, SROM_CTL,    0);
 }
 
 static void nsp32_prom_stop (nsp32_hw_data *data)
 {
 	/* stop condition */
-	nsp32_prom_set(data, SCL, 1);
-	nsp32_prom_set(data, SDA, 0);
-	nsp32_prom_set(data, ENA, 1);	/* output mode */
-	nsp32_prom_set(data, SDA, 1);
-	nsp32_prom_set(data, SCL, 0);
+	nsp32_prom_set(data, SROM_CTL,    1);
+	nsp32_prom_set(data, SROM_DATA,   0);
+	nsp32_prom_set(data, SROM_ENABLE, 1);	/* output mode */
+	nsp32_prom_set(data, SROM_DATA,   1);
+	nsp32_prom_set(data, SROM_CTL,    0);
 }
 
-static void nsp32_prom_write (nsp32_hw_data *data, int val)
+static void nsp32_prom_write_bit(nsp32_hw_data *data, int val)
 {
 	/* write */
-	nsp32_prom_set(data, SDA, val);
-	nsp32_prom_set(data, SCL, 1);
-	nsp32_prom_set(data, SCL, 0);
+	nsp32_prom_set(data, SROM_DATA, val);
+	nsp32_prom_set(data, SROM_CTL,  1  );
+	nsp32_prom_set(data, SROM_CTL,  0  );
 }
 
-static int nsp32_prom_fetch (nsp32_hw_data *data)
+static int nsp32_prom_read_bit(nsp32_hw_data *data)
 {
 	int val;
 
 	/* read */
-	nsp32_prom_set(data, ENA, 0);	/* input mode */
-	nsp32_prom_set(data, SCL, 1);
-	val = nsp32_prom_get(data, SDA);
-	nsp32_prom_set(data, SCL, 0);
-	nsp32_prom_set(data, ENA, 1);	/* output mode */
-	return (val);
+	nsp32_prom_set(data, SROM_ENABLE, 0);	/* input mode */
+	nsp32_prom_set(data, SROM_CTL,    1);
+
+	val = nsp32_prom_get(data, SROM_DATA);
+
+	nsp32_prom_set(data, SROM_CTL,    0);
+	nsp32_prom_set(data, SROM_ENABLE, 1);	/* output mode */
+
+	return val;
 }
 
 static inline void nsp32_prom_set(nsp32_hw_data *data, int bit, int val)
 {
-	int cur;
-	int base = data->BaseAddress;
+	unsigned int base = data->BaseAddress;
+	int tmp;
 
-	switch(val) {
-	case 0:
-		cur = nsp32_index_read1(base, SERIAL_ROM_CTL);
-		nsp32_index_write1(base, SERIAL_ROM_CTL, cur & ~bit);
-		break;
-	case 1:
-		cur = nsp32_index_read1(base, SERIAL_ROM_CTL);
-		nsp32_index_write1(base, SERIAL_ROM_CTL, cur | bit);
-		break;
-	default:
-		nsp32_msg(KERN_ERR, "val must be 0 or 1");
-		return;
+	tmp = nsp32_index_read1(base, SERIAL_ROM_CTL);
+
+	if (val == 0) {
+		tmp &= ~bit;
+	} else {
+		tmp |=  bit;
 	}
 
+	nsp32_index_write1(base, SERIAL_ROM_CTL, tmp);
+
 	udelay(10);
 }
 
 static inline int nsp32_prom_get(nsp32_hw_data *data, int bit)
 {
-	int ret;
-	int base = data->BaseAddress;
+	unsigned int base = data->BaseAddress;
+	int tmp, ret;
 
-	ret = nsp32_index_read1(base, SERIAL_ROM_CTL) & bit;
-	switch (ret) {
-	case 0:
+	if (bit != SROM_DATA) {
+		nsp32_msg(KERN_ERR, "return value is not appropriate");
+		return 0;
+	}
+
+
+	tmp = nsp32_index_read1(base, SERIAL_ROM_CTL) & bit;
+
+	if (tmp == 0) {
 		ret = 0;
-		break;
-	case SDA:
+	} else {
 		ret = 1;
-		break;
-	default:
-		nsp32_msg(KERN_ERR, "return value is not appropriate");
 	}
 
 	udelay(10);
 
-	return (ret);
+	return ret;
+}
+
+
+/**************************************************************************
+ * Power Management
+ */
+#ifdef CONFIG_PM
+/* Save Device Context */
+static int nsp32_save_state(struct pci_dev *pdev, u32 state)
+{
+	struct Scsi_Host *host = pci_get_drvdata(pdev);
+
+	nsp32_msg(KERN_INFO, "pci-save_state: stub, pdev=0x%p, state=%ld, slot=%s, host=0x%p", pdev, state, pci_name(pdev), host);
+
+	return 0;
+}
+
+/* Device suspended */
+static int nsp32_suspend(struct pci_dev *pdev, u32 state)
+{
+	struct Scsi_Host *host = pci_get_drvdata(pdev);
+	nsp32_hw_data    *data = (nsp32_hw_data *)host->hostdata;
+
+	nsp32_msg(KERN_INFO, "pci-suspend: pdev=0x%p, state=%ld, slot=%s, host=0x%p", pdev, state, pci_name(pdev), host);
+
+	pci_save_state     (pdev, data->PciState);
+	pci_disable_device (pdev);
+	pci_set_power_state(pdev, state);
+
+	return 0;
+}
+
+/* Device woken up */
+static int nsp32_resume(struct pci_dev *pdev)
+{
+	struct Scsi_Host *host = pci_get_drvdata(pdev);
+	nsp32_hw_data    *data = (nsp32_hw_data *)host->hostdata;
+	unsigned short    reg;
+
+	nsp32_msg(KERN_INFO, "pci-resume: pdev=0x%p, slot=%s, host=0x%p", pdev, pci_name(pdev), host);
+
+	pci_set_power_state(pdev, 0);
+	pci_enable_wake    (pdev, 0, 0);
+	pci_restore_state  (pdev, data->PciState);
+
+	reg = nsp32_read2(data->BaseAddress, INDEX_REG);
+
+	nsp32_msg(KERN_INFO, "io=0x%x reg=0x%x", data->BaseAddress, reg);
+
+	if (reg == 0xffff) {
+		nsp32_msg(KERN_INFO, "missing device. abort resume.");
+		return 0;
+	}
+
+	nsp32hw_init      (data);
+	nsp32_do_bus_reset(data);
+
+	nsp32_msg(KERN_INFO, "resume success");
+
+	return 0;
+}
+
+/* Enable wake event */
+static int nsp32_enable_wake(struct pci_dev *pdev, u32 state, int enable)
+{
+	struct Scsi_Host *host = pci_get_drvdata(pdev);
+
+	nsp32_msg(KERN_INFO, "pci-enable_wake: stub, pdev=0x%p, enable=%d, slot=%s, host=0x%p", pdev, enable, pci_name(pdev), host);
+
+	return 0;
+}
+#endif
+
+/************************************************************************
+ * PCI/Cardbus probe/remove routine
+ */
+static int __devinit nsp32_probe(struct pci_dev *pdev, const struct pci_device_id *id)
+{
+	int ret;
+	nsp32_hw_data *data = &nsp32_data_base;
+
+	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
+
+        ret = pci_enable_device(pdev);
+	if (ret) {
+		nsp32_msg(KERN_ERR, "failed to enable pci device");
+		return ret;
+	}
+
+	data->Pci         = pdev;
+	data->pci_devid   = id;
+	data->IrqNumber   = pdev->irq;
+	data->BaseAddress = pci_resource_start(pdev, 0);
+	data->NumAddress  = pci_resource_len  (pdev, 0);
+	data->MmioAddress = 
+		(unsigned long)ioremap_nocache(pci_resource_start(pdev, 1),
+					       pci_resource_len  (pdev, 1));
+	data->MmioLength  = pci_resource_len  (pdev, 1);
+
+	pci_set_master(pdev);
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+	ret = nsp32_detect(pdev);
+#else
+	ret = scsi_register_host(&nsp32_template);
+#endif
+
+	nsp32_msg(KERN_INFO, "irq: %i mmio: 0x%lx+0x%lx slot: %s model: %s",
+		  pdev->irq,
+		  data->MmioAddress, data->MmioLength,
+		  pci_name(pdev),
+		  nsp32_model[id->driver_data]);
+
+	nsp32_dbg(NSP32_DEBUG_REGISTER, "exit %d", ret);
+
+	return ret;
+}
+
+static void __devexit nsp32_remove(struct pci_dev *pdev)
+{
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+	struct Scsi_Host *host = pci_get_drvdata(pdev);
+#endif
+
+	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+        scsi_remove_host(host);
+
+	nsp32_release(host);
+
+	scsi_host_put(host);
+#else
+	scsi_unregister_host(&nsp32_template);	
+#endif
+}
+
+
+
+static struct pci_driver nsp32_driver = {
+	.name		= "nsp32",
+	.id_table	= nsp32_pci_table,
+	.probe		= nsp32_probe,
+	.remove		= __devexit_p(nsp32_remove),
+#ifdef CONFIG_PM
+	.save_state     = nsp32_save_state,
+	.suspend	= nsp32_suspend, 
+	.resume		= nsp32_resume, 
+	.enable_wake    = nsp32_enable_wake,
+#endif
+};
+
+/*********************************************************************
+ * Moule entry point
+ */
+static int __init init_nsp32(void) {
+	nsp32_msg(KERN_INFO, "loading...");
+	return pci_module_init(&nsp32_driver);
+}
+
+static void __exit exit_nsp32(void) {
+	nsp32_msg(KERN_INFO, "unloading...");
+	pci_unregister_driver(&nsp32_driver);
 }
 
+module_init(init_nsp32);
+module_exit(exit_nsp32);
+
 /* end */
